#ifndef bqSummA_hh
#define bqSummA_hh

#include <map>

using std::map;

#include "autoptr.hh"
#include "zero.hh"
#include "elem.hh"

extern bool SummaDebug;
extern bool CombineDebug;

class summa : public Elem
{
	// Elementti, kerroin
	
	typedef map<elemp, merknum> elemap;
	
	friend class Parser;
	
	elemap elems;
	
public:
	merknum lisays;
	
	summa() : Elem('+')
	{
	}
	
	void insert(elemp p, const merknum n = 1.0L)
	{
		if(p->type == '+')
		{
			const summa &tmp = *(const summa *)&*p;
			lisays += n * tmp.lisays;
			for(elemap::const_iterator i=tmp.elems.begin(); i!=tmp.elems.end(); ++i)
				elems[i->first] += i->second * n;
			return;
		}
		elems[p] += n;
	}
	void erase(elemp p, const merknum n = 1.0L) { insert(p, -n); }
	
	summa& operator*= (elemp p);

	inline unsigned size() const { return elems.size(); }

	virtual bool operator== (const Elem &e) const;
	virtual bool operator< (const Elem &e) const;

	virtual elemp Expand();
	virtual elemp Combine();
	virtual void Yksmuu(class Yksikkomuunnokset &how);
};

typedef autoeqptr<summa> summap;

#endif
