#include <iostream>

using std::cout;

#include "tulo.hh"
#include "summa.hh"

extern void Dump(elemp res);

bool TuloDebug = false;

bool tulo::operator== (const Elem &e) const
{
    if(type != e.type)return false;
    const tulo &tmp = *(const tulo *)&e;
    return elems == tmp.elems;
}
bool tulo::operator< (const Elem &e) const
{
    if(type < e.type)return true;
    if(type > e.type)return false;
    const tulo &tmp = *(const tulo *)&e;
    
    unsigned b=tmp.size();
    
    if(size() < b)return true;
    if(size() > b)return false;
    
    elemap::const_iterator i, j;
    
    for(i=elems.begin(), j=tmp.elems.begin();
        i!=elems.end();
        ++i, ++j)
    {
        if(i->second < j->second)return true;
        if(i->second > j->second)return false;
        if(i->first < j->first)return true;
    }
    return false;
}

elemp tulo::Expand()
{
    elemap::iterator i;
    if(TuloDebug)cout << "Tulo::Expand()\n";
retry:
    if(TuloDebug) { cout << "Tulo expanding: "; Dump(this); }
    if(elems.size() == 1)
    {
        elemap::iterator j = elems.begin();
        if(j->second == 1)
        {
            if(TuloDebug) { cout << "Tulo: Became child: "; Dump(this); }
            return j->first->Expand();
        }
    }
    for(i=elems.begin(); i!=elems.end(); ++i)
    {
        if(i->second == 0)
        {
            if(TuloDebug)cout << "Tulo: Dropped something\n";
            elems.erase(i);
            goto retry;
        }
        if(i->first->type == '*')
        {
            tulop j = (tulo *)&*i->first;
            elems.erase(i);
            if(TuloDebug) { cout << "Tulo: Combining self with "; Dump(&*j); }
            for(elemap::iterator k = j->elems.begin();
                                 k!= j->elems.end();
                                 ++k)
            {
                elems[k->first] += k->second;
            }
            /* Jumping out of this scope uninitializes j,
             * and causes the pointer to be deallocated.
             */
            if(TuloDebug)cout << "Tulo: Combined with *\n";
            goto retry;
        }
    }
    for(i=elems.begin(); i!=elems.end(); ++i)
    {
        if(i->first->type == '+')
        {
        	if(i->second >= 1 /* || i->second < -1 */)
            {
                summap j = (summa *)&*i->first->Expand();
                
                if(TuloDebug)
                {
                    cout << "Tulo: --- Currently: "; Dump(this);
                }
                
                real newpot = i->second;
                if(newpot > 0)--newpot;else ++newpot;
                
                if(newpot == 0)
                    elems.erase(i);
                else
                    elems[i->first] = newpot;
                    
                elemp t = Expand();
                
                if(TuloDebug)
                {
                    cout << "Tulo: --- Becoming "; Dump(t);
                }

                if(i->second < 0)
                {
	                if(TuloDebug) { cout << "      --- divided with "; Dump(&*j); }
                	tulop th = new tulo;
                	th->insert(t, 1);
                	th->insert(&*j, -1);
                	t = th->Expand();
                }
                else
                {
	                if(TuloDebug) { cout << "      --- multiplied with "; Dump(&*j); }
	                *j *= t;
	                t = j->Expand();
	            }
                
                if(TuloDebug) { cout << "      --- result = "; Dump(t); }
                
                return t;
            }
            /*
            
            Summasta ei saa supistaa. Siis 1/(a+b) ei voi muuttua
            tuosta miksikn, eik etenkn 1/a + 1/b :ksi.
            
            Mutta mitenk tehdn se, ett 1/(a+b)^2 -> 1/(a^2 + b^2 + 2ab)
            	
            */
        }
    }
    elemap nmap;
    if(TuloDebug) { cout << "Tulo almost done: "; Dump(this); }
    for(i=elems.begin(); i!=elems.end(); ++i)
        nmap[i->first->Expand()] += i->second;
    if(elems != nmap)
    {
        elems = nmap;
        if(TuloDebug)cout << "Tulo: Did something, rerunning\n";
        goto retry;
    }
    if(TuloDebug) { cout << "Tulo done: "; Dump(this); }
    return new tulo(*this);
}

elemp tulo::Combine()
{
    elemap::iterator i;
    if(TuloDebug)cout << "Tulo::Combine()\n";
retry:
    if(TuloDebug) { cout << "Tulo combining: "; Dump(this); }
    if(elems.size() == 1)
    {
        elemap::iterator j = elems.begin();
        if(j->second == 1)
        {
            if(TuloDebug)cout << "Tulo: Became child\n";
            return j->first->Combine();
        }
    }
    for(i=elems.begin(); i!=elems.end(); ++i)
    {
        if(i->second == 0)
        {
            if(TuloDebug)cout << "Tulo: Dropped something\n";
            elems.erase(i);
            goto retry;
        }
    }
    elemap nmap;
    for(i=elems.begin(); i!=elems.end(); ++i)
        nmap[i->first->Combine()] += i->second;
    if(elems != nmap)
    {
        elems = nmap;
        if(TuloDebug)cout << "Tulo: Did something, rerunning\n";
        goto retry;
    }
    if(TuloDebug) { cout << "Tulo done: "; Dump(this); }
    return new tulo(*this);
}
